Patchwork [1/1] gawk: enable ptest support

login
register
mail settings
Submitter Chong.Lu@windriver.com
Date Jan. 22, 2014, 4:55 a.m.
Message ID <b40f906d0553210df97d848dfc3ba956b2b05ff6.1390366473.git.Chong.Lu@windriver.com>
Download mbox | patch
Permalink /patch/65503/
State New
Headers show

Comments

Chong.Lu@windriver.com - Jan. 22, 2014, 4:55 a.m.
Install gawk test suite and run it as ptest.

Signed-off-by: Chong Lu <Chong.Lu@windriver.com>
---
 meta/recipes-extended/gawk/gawk-4.0.2/run-ptest | 10 ++++++++++
 meta/recipes-extended/gawk/gawk_4.0.2.bb        | 13 ++++++++++++-
 2 files changed, 22 insertions(+), 1 deletion(-)
 create mode 100644 meta/recipes-extended/gawk/gawk-4.0.2/run-ptest

Patch

diff --git a/meta/recipes-extended/gawk/gawk-4.0.2/run-ptest b/meta/recipes-extended/gawk/gawk-4.0.2/run-ptest
new file mode 100644
index 0000000..7d214ea
--- /dev/null
+++ b/meta/recipes-extended/gawk/gawk-4.0.2/run-ptest
@@ -0,0 +1,10 @@ 
+#!/bin/sh
+
+cd test
+for i in `grep -vE "@|^$|#|Gt-dummy" Maketests |awk -F: '{print $1}'`; \
+  do LC_ALL=${GAWKLOCALE:-C} LANG=${GAWKLOCALE:-C} srcdir=`pwd` AWK=gawk CMP=cmp \
+  make -f Maketests $i &>$i.tmp; \
+  grep -q "Error" $i.tmp; \
+  if [ $? == 0 ]; then echo "FAIL: $i"; \
+  else echo "PASS: $i"; rm -f $i.tmp; fi; \
+done
diff --git a/meta/recipes-extended/gawk/gawk_4.0.2.bb b/meta/recipes-extended/gawk/gawk_4.0.2.bb
index 424b6b0..eb86af3 100644
--- a/meta/recipes-extended/gawk/gawk_4.0.2.bb
+++ b/meta/recipes-extended/gawk/gawk_4.0.2.bb
@@ -16,7 +16,9 @@  DEPENDS += "readline"
 RDEPENDS_gawk += "gawk-common"
 RDEPENDS_pgawk += "gawk-common"
 
-SRC_URI = "${GNU_MIRROR}/gawk/gawk-${PV}.tar.gz"
+SRC_URI = "${GNU_MIRROR}/gawk/gawk-${PV}.tar.gz \
+           file://run-ptest \
+"
 
 SRC_URI[md5sum] = "4d505dc2c9f1eb3e9f8d6cac87d4bd1a"
 SRC_URI[sha256sum] = "6e0de117c3713aa8d7fa347fc9fd645b10038ae49d8cf947d8c1d51cbb76141a"
@@ -39,3 +41,12 @@  do_install_append() {
 	# remove the link since we don't package it
 	rm ${D}${bindir}/awk
 }
+
+inherit ptest
+
+do_install_ptest() {
+	mkdir ${D}${PTEST_PATH}/test
+	for i in `grep -vE "@|^$|#|Gt-dummy" ${S}/test/Maketests |awk -F: '{print $1}'` Maketests; \
+	  do cp ${S}/test/$i* ${D}${PTEST_PATH}/test; \
+	done
+}